/***************************************************************************
                          dataloader.cpp  -  description
                             -------------------
    begin                : Mon Jan 31 2000
    copyright            : (C) 2000 by Michael Dittenbach
    email                : mbach@ifs.tuwien.ac.at
 ***************************************************************************/



#include "dataloader.h"

#include "globals.h"
#include <cstdlib>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>

DataLoader::DataLoader(){
}
DataLoader::~DataLoader(){
}
/**  */
Data_Vector* DataLoader::readDataItems(char *ifName){
	ifstream inFile(ifName);
	if (!inFile) {
		cout << "inputfile not found (check propertyfile)" << endl;
		exit(EXIT_FAILURE);
	}
	Data_Vector *res = new Data_Vector();
	char *veclen, *numdat, *element, *dummy;
	inFile.gets(&dummy,'\n'); //$TYPE
	inFile.gets(&dummy,' '); //$XDIM
	inFile.gets(&numdat,'\n'); //$XDIM value
	inFile.gets(&dummy,'\n'); //$YDIM
	inFile.gets(&dummy,' '); //$VEC_DIM
	inFile.gets(&veclen,'\n'); //$VEC_DIM value

	//	inFile.gets(&veclen,'\n');
	//	inFile.gets(&numdat,'\n');
	dataLength = atoi(veclen);
	Globals::vectorlength = dataLength;
	numVectors = atoi(numdat);
	Globals::numofallvecs = numVectors;
	int debuggy = 0;
	for (int j=0;j<numVectors;j++) {
		float *data = (float*) calloc(dataLength,sizeof(float));
		for (int i=0;i<dataLength;i++) {
		  inFile.gets(&element,' ');
		  data[i] = atof(element);
		}
		//inFile.gets(&element,'\n');
		//data[dataLength-1] = atof(element);

		if (Globals::normInputVectors==NORM_LENGTH) {
			data = Globals::normVec(data);
    }// else if (Globals::normInputVectors==NORM_INTERVAL) {
			//data = Globals::normIntervalVector(data);
		//}
		char *id;
		inFile.gets(&id,'\n');
		DataItem *di = new DataItem(id,data,dataLength);
		res->addElement(di);
		cout << "added " << id << endl;
	}
	if (Globals::normInputVectors==NORM_INTERVAL) {
   	res = Globals::normIntervalVector(res);
	}
  return res;
}
/**  */
bool DataLoader::providesVectorDescription(){
	return true;
}
/**  */
char** DataLoader::getVectorDescription(){
	return vectorDescription;
}
/**  */
void DataLoader::readVectorDescription(char* dfName){
	ifstream dfFile(dfName);
	if (!dfFile) {
		cout << "descriptionfile not found (check propertyfile)" << endl;
		exit(EXIT_FAILURE);
	}
	vectorDescription = (char**) calloc(dataLength,sizeof(char*));
	char *dummy;
	dfFile.gets(&dummy,'\n');//$TYPE
	dfFile.gets(&dummy,'\n');//$XDIM
	dfFile.gets(&dummy,'\n');//$YDIM
	dfFile.gets(&dummy,'\n');//$VEC_DIM
	for (int i=0;i<dataLength;i++) {
	  dfFile.gets(&dummy,' ');//index
	  dfFile.gets(&vectorDescription[i],' ');
	  dfFile.gets(&dummy,'\n');//rest
	}
	dfFile.close();
	free(dummy);
}
